#!/bin/sh 

PGBIN_PATH=/usr/iwss/PostgreSQL/bin

usage()
{
	echo "Usage: "
	echo "$0 <HOST_NAME> <DB_PORT> <DB_USER> <DATABASE_NAME> [PGBIN_PATH]"
	exit
}

if ([ "$#" -lt "4" ] || [ "$#" -gt "5" ]) ; then
	usage
fi

HOST_NAME=$1
DB_PORT=$2
DBUSER=$3
DATABASE_NAME=$4

if [ $# = 5 ] ; then
	PGBIN_PATH=$5
	if [ ! -d $PGBIN_PATH ] ; then
		echo "The directory you specified: '$PGBIN_PATH' does not exist!"
		exit 1
	fi
fi
if [ -z "$HOST_NAME" ] ; then
	HOST_NAME=localhost
fi
if [ -z "$DB_PORT" ] ; then
	DB_PORT=5432
fi
if [ -z "$DATABASE_NAME" ] ; then
	DATABASE_NAME=iwss
fi
if [ -z "$DBUSER" ] ; then
	DBUSER=sa
fi

#echo "hostname: $HOST_NAME"
#echo "port: $DB_PORT"
#echo "user: $DBUSER"
#echo "dbname: $DATABASE_NAME"
#echo "pgbin: $PGBIN_PATH"

echo "###############################################################################"
echo "Start to vacuum DB, it may take some time and depend on the size of database..."
echo "###############################################################################"
tmp_name_vacuum=/tmp/tmp_task_vacuum_$$
dosql=0

$PGBIN_PATH/psql -h $HOST_NAME -p $DB_PORT -U $DBUSER $DATABASE_NAME << end_of_file > $tmp_name_vacuum
select task_start from tb_task where task_name = 'vacuum';
end_of_file
grep 0 $tmp_name_vacuum > /dev/null

if [ $? = 0 ] ; then
	dosql=1
else
	ps -ef | grep $0 | grep -v $$ | grep -v grep > /dev/null
	if [ $? != 0 ] ; then
		dosql=1
	fi
fi
if [ $dosql = 1 ] ; then
$PGBIN_PATH/psql -h $HOST_NAME -p $DB_PORT -U $DBUSER $DATABASE_NAME << end_of_file
update tb_task set task_start = 1 where task_name = 'vacuum';
vacuum full analyze;
update tb_task set task_start = 0 where task_name = 'vacuum';
end_of_file
fi
if [ -e $tmp_name_vacuum ] ; then
	rm -f $tmp_name_vacuum
fi
