#!/bin/sh 

PGBIN_PATH=/usr/iwss/PostgreSQL/bin

usage()
{
	echo "Usage: "
	echo "$0 <HOST_NAME> <DB_PORT> <DB_USER> <DATABASE_NAME> [PGBIN_PATH]"
	exit
}
if ([ "$#" -lt 4 ] || [ "$#" -gt 5 ]) ; then 
	usage
fi

HOST_NAME=$1
DB_PORT=$2
DBUSER=$3
DATABASE_NAME=$4

if [ $# = 5 ] ; then
	PGBIN_PATH=$5
	if [ ! -d $PGBIN_PATH ] ; then
		echo "The directory you specified: '$PGBIN_PATH' does not exist!"
		exit 1
	fi
fi
if [ -z "$HOST_NAME" ] ; then
	HOST_NAME=localhost
fi
if [ -z "$DB_PORT" ] ; then
	DB_PORT=5432
fi
if [ -z "$DATABASE_NAME" ] ; then
	DATABASE_NAME=iwss
fi
if [ -z "$DBUSER" ] ; then
	DBUSER=sa
fi

#echo "hostname: $HOST_NAME"
#echo "port: $DB_PORT"
#echo "user: $DBUSER"
#echo "db name: $DATABASE_NAME"
#echo "pgbin: $PGBIN_PATH"
tmp_name_index=/tmp/tmp_task_index_$$
dosql=0

$PGBIN_PATH/psql -h $HOST_NAME -p $DB_PORT -U $DBUSER $DATABASE_NAME << end_of_file > $tmp_name_index
select task_start from tb_task where task_name ='reindex';
end_of_file
grep 0 $tmp_name_index > /dev/null

if [ $? = 0 ] ; then
	dosql=1
else
	ps -ef | grep $0 | grep -v $$ | grep -v grep > /dev/null
	if [ $? != 0 ] ; then
		dosql=1
	fi
fi
if [ $dosql = 1 ] ; then
$PGBIN_PATH/psql -h $HOST_NAME -p $DB_PORT -U $DBUSER $DATABASE_NAME << end_of_file 
update tb_task set task_start = 1 where task_name = 'reindex';
reindex table tb_EntityType;
reindex table tb_PolicyType;
reindex table tb_PriorityList;
reindex table tb_Policy;
reindex table tb_Rule;
reindex table tb_Entity;
reindex table tb_report_by; 
reindex table tb_url_usage;
reindex table tb_violation;
reindex table tb_performance_value;
reindex table tb_search_engine;
reindex table tb_cleanup;
reindex table tb_QuotaConsumption;
reindex table tb_tx_count;
reindex table tb_tx_cat_count;
reindex table tb_violation_count;
reindex table tb_tx_time;
reindex table tb_throughput;
reindex table tb_res_utilization;
update tb_task set task_start = 0 where task_name = 'reindex';
end_of_file
fi

if [ -e $tmp_name_index ] ; then
	rm -f $tmp_name_index
fi 
