#!/bin/sh

##################################################################################
# This program is ONLY executed by "root".
# Notes: Waiting for complete start is not a well-defined operation and may fail
# if access control is set up so that a local client cannot connect without manual
# interaction. e.g. password authentication
##################################################################################

usage()
{
	echo "$0 <start|stop|status|reload|restart>"
	exit
}

if [ $# = 2 ] ; then
	PG_BASE=$2
	if [ ! -d $PG_BASE  ] ; then
		echo "The driectory $PG_BASE you specified does not exist!"
		exit 110
	fi
else
	PG_BASE=/usr/iwss/PostgreSQL
fi
if [ ! -x $PG_BASE/bin/pg_ctl ] ; then
	echo "$PG_BASE/bin/pg_ctl is not executable!"
	exit 110 	
fi

PG_BIN_DIR=$PG_BASE/bin
PG_LIB_DIR=$PG_BASE/lib
PGDATA=/var/iwss/postgres/pgdata
#PG_LOG_FILE=/var/iwss/postgres/pglog
POSTGRES_PID=$PGDATA/postmaster.pid

PATH=$PG_BIN_DIR:$PATH
LD_LIBRARY_PATH=$PG_LIB_DIR:$LD_LIBRARY_PATH
export PATH LD_LIBRARY_PATH
export PGDATA

#echo $PG_BASE
#echo $PG_BIN_DIR
#echo $PG_LIB_DIR
#echo $PGDATA
#echo $PATH
#echo $LD_LIBRARY_PATH

case $1 in
	start)
		if [ -f $POSTGRES_PID ] ; then
			if ps -ef | grep /usr/iwss/PostgreSQL/bin/postmaster | grep -v grep > /dev/null 2>&1 ; then
				:
			else
				rm -f $POSTGRES_PID
			fi
		fi
		pg_ctl -w -o "-i" start
		;;
	stop)
		pg_ctl -w -m fast stop
		;;
	status)
		pg_ctl status
		;;
	reload)
		pg_ctl reload
		;;
	restart)
		pg_ctl -w -m fast -o "-i" restart
		;;
	*)
		usage
		;;
esac

