BEGIN {
	sectionFound=0;
	inSection=0;
	targetFound=0;
}
{
	if ($1 == "[" section "]") {
		sectionFound = 1;
		inSection = 1;
		print $0;
		next;
	} else {
		if ($1 ~ /^\[.*\]/) {
			if (inSection) {
				inSection = 0;
				if (! targetFound) {
					targetFound=1;
					printf("%s%s%s\n", key, sep, value);
				}
			}
			print $0;
			next;
		}
	}
	if (inSection) {
		pattern = "^" key " *[" sep "]";
		if ( $0 ~ pattern ) {
			targetFound=1;
			printf("%s%s%s\n", key, sep, value);
		} else {
			print $0;
		}
	} else {
		print $0;
	}
}
END {
	if (! targetFound) {
		if (! sectionFound) {
			printf("\n[%s]\n", section);
			printf("%s%s%s\n", key, sep, value);
		} else {
			# -- the section was the last one
			printf("\n%s%s%s\n", key, sep, value);
		}
	}
}
