#!/bin/sh

ISCAN_BASE_DIR=/etc/iscan
SCRIPTS_DIR=$ISCAN_BASE_DIR/arm_scripts

logErr()
{
	echo $1 1>&2
}

if [ ! -d $SCRIPTS_DIR ] ; then
	logErr "ARM scripts directory is not accessible: $SCRIPTS_DIR"
	exit 1
fi

cd $SCRIPTS_DIR

exitCode=0

activatedHost=`./arm_status.sh`
activated=$?

if [ $activated -eq 0 ] ; then
	if [ "$1" = "-h" ] ; then
		echo "$activatedHost"
	else
		echo "yes"
	fi
else
	echo "no"
fi
