#!/bin/sh

TMP_SECTION=TmpAppliedFileRecord
APPLIED_RECORD_SECTION=AppliedFileRecord
BACKUP_APPLIED_RECORD_SECTION=BackupAppliedFileRecord
BACKUP_TAR=Backup.tgz

#This contains the files for smart rollback
SMART_BACKUP_TAR=SmartBackup.tgz

F_stop_daemons() {
#    force stop CM agent
#        /etc/iscan/rcIwss stop   comment out due to the CM agent may not stop in time - by MichaelH
        /usr/iwss/S99ISsvcmonitor stop
        /etc/iscan/ISAGENT_MCP/stopmcp.sh force

	for s in canHttpd ftp logtodb maild proxy database MetricMgmtd ; do
		/usr/iwss/S99IS$s stop
	done

#	_install_dir=$1
#
#	_restartUI=`F_ini_get $PATCHINFOINI PatchInfo RestartUI`
#	_restartWeb=`F_ini_get $PATCHINFOINI PatchInfo RestartWeb`
#	_restartMail=`F_ini_get $PATCHINFOINI PatchInfo RestartMail`
#	_restartSystem=`F_ini_get $PATCHINFOINI PatchInfo RestartSystem`
#	if [ "$_restartUI" = "1" -o "$_restartSystem" = 1 ] ; then
#		echo "[[StopUI]] Stopping the web console."
#		# We sleep five seconds to wait for web console. It will stop refreshing when Stopping daemons is in the log.
#		sleep 10
#	fi
#	$_install_dir/script/mail/ISsysmon stop
#	
#	if [ "$_restartMail" = 1 ] ; then
#		$_install_dir/script/mail/ISmss stop
#	fi
#
#	if [ "$_restartUI" = 1 ] ; then
#		$_install_dir/script/ISui stop
#	fi
#
#	if [ "$_restartMail" = 1 -o "$_restartUI" = "1" ] ; then
#		$_install_dir/script/mail/ISreg stop
#	fi
#	
#	if [ "$_restartWeb" = 1 ] ; then
#		$_install_dir/script/web/ISftp stop
#		$_install_dir/script/web/ISproxy stop
#		$_install_dir/script/web/ISmaild stop
#	fi
	
}

F_start_daemons() {
	
	_restartSystem=`F_ini_get $PATCHINFOINI PatchInfo RestartSystem`
	if [ "$_restartSystem" = "1" ] ; then
		echo "Rebooting the system."
		reboot
		return 0
	fi
	
	echo "Starting all daemons."
	_install_dir=$1

        /etc/iscan/rcIwss start
	#for s in database urld maild proxy logtodb ftp canHttpd agent svcmonitor ; do
	#	/usr/iwss/S99IS$s start
	#done
}

# backup a list of files to a dir
# $1 install root dir 
# $2 backup dir
F_rollback(){

	echo "Rollback the files from backup dir $2 ..."
	_index=0
	_install_root=$1
	_backup_dir=$2

	if [ -f "$_backup_dir/$BACKUP_TAR" ] ; then
		echo "Rollback from $BACKUP_TAR"
		tar zxvf "$_backup_dir/$BACKUP_TAR" -C /
	else
		echo "No rollback because no $BACKUP_TAR." 
	fi
	
	if [ -f "$_backup_dir/$SMART_BACKUP_TAR" ] ; then
		echo "Rollback from $SMART_BACKUP_TAR"
		tar zxvf "$_backup_dir/$SMART_BACKUP_TAR" -C /
	else
		echo "No smart rollback because no $SMART_BACKUP_TAR." 
	fi

	return 0
}


